<?PHP
  ///////////////////////////////////////////////////////////////////////
  // General Functions  - MM passed

  // -- getserverdata($ip,$port,$cmd) -- //
function getserverdata($ip,$port,$cmd)
{
	global $conf;
	
	if (!$socket=@fsockopen("udp://".$ip,$port,&$errno,&$errstr,1))
	{
		return FALSE;
	}
	else
	{
		socket_set_blocking($socket,true);
		if($conf['TimeoutAvail']) { socket_set_timeout($socket,5,0); }
		fwrite($socket,$cmd,strlen($cmd));
		$serverdata="";
		do {
		   $serverdata .= fgetc($socket);
		   $socketstatus = socket_get_status($socket);
		   }
		   while ($socketstatus["unread_bytes"]);
		fclose($socket);
		return $serverdata;
	}
}

// -- sort_by_points($a,$b) -- //
function sort_by_points ($a, $b) {
  return strnatcmp($a["frags"],$b["frags"]);
}

// -- sort_by_ping($a,$b) -- //
function sort_by_ping ($a, $b) {
  return strnatcmp($a["ping"],$b["ping"]);
}

// -- sort_by_name($a,$b) -- //
function sort_by_name ($a, $b) {
  return strcasecmp($b["name"],$a["name"]);
}

// -- sort_by_team($a,$b) -- //
function sort_by_team ($a, $b) {
  return strcasecmp($a["team"],$b["team"]);
}

// -- ads() -- // (thx 4 using this function)
function ads() {
  echo "<CENTER>";
  echo "<table width=\"600\" bgcolor=\"$c_header\" class=\"head\">";
  echo "<tr>";
  echo "<td class=\"left\" align=\"center\">&COPY; copyright <A HREF=\"http://www.blank-clan.de\" TARGET=\"_blank\">blank-clan.de</A> and <A HREF=\"http://www.ut-2003.com\" TARGET=\"_blank\">ut-2003.com</A>";
  echo "<BR>";
  echo "Script coded by <a href=\"mailto:gerde@blank-clan.de\">[[:blank:]]Gerde</a> and cleaned/extended by <a href=\"mailto:moon@justmoon.com\">moon</a> & <a href=\"mailto:smurf@PlanetAnime.info\">smurf</a>.</td>";
  echo "</tr>";
  echo "</table>";
  echo "</CENTER>";
}

  ///////////////////////////////////////////////////////////////////////
  // Unreal Tournament 2003 Support (Demo)

  // -- ut2k3_info($address, $port) -- //
    function ut2k3_info($address, $port) {

	// send command and receive answer
	$cmd="\\basic\\";
	$queryport=$port+10;
	if(!($response=getserverdata($address,$queryport,$cmd))) {
      return FALSE;
	}
	$cmd="\\info\\";
	if(!($response.=getserverdata($address,$queryport,$cmd))) {
      return FALSE;
	}

	// seperate the answer
	$tmp=explode("\\",$response);
	for($i=1;$i<count($tmp);$i++) {
      $varname=$tmp[$i];
      $i++;
      $tmpinfo[$varname]=$tmp[$i];
	}

	// sync with GameserverQuery-protocol
	$info = array();
	$info["hostname"]	= $tmpinfo["hostname"];
	$info["address"]	= $address;
	$info["port"]		= $tmpinfo["hostport"];
	$info["game"]		= $tmpinfo["gamename"];
	$info["gamename"]	= "Unreal Tournament 2003";
	$info["map"]		= $tmpinfo["mapname"];
	$info["mapname"]	= $tmpinfo["maptitle"];
	$info["numplayers"]	= $tmpinfo["numplayers"];
	$info["maxplayers"]	= $tmpinfo["maxplayers"];
	$info["gametype"]	= $tmpinfo["gametype"];
	$info["version"]	= $tmpinfo["gamever"];
	$info["misc1"]		= $tmpinfo["location"];
	
	// return the information
	return $info;
    }


  // -- ut2k3_players($address, $port[, $sort]) -- //
  function ut2k3_players($address, $port, $sort="none") {
	// send command and receive answer
	$cmd="\\players\\";
	$queryport=$port+10;
	if(!($response=getserverdata($address,$queryport,$cmd)))
	{
		return FALSE;
	}

	// seperate the answer
	$tmp=explode("\\",$response);

	// order player data
	for($i=1;$i<count($tmp);$i++)
	{
		$varname=$tmp[$i];
		$i++;
		$tmpplayer[$varname]=$tmp[$i];
	}

	// get current player count
	$temp=ut2k3_info($address, $port);

	// sync with GameserverQuery-protocol
	for($i=0;$i<$temp["numplayers"];$i++)
	{
		$player[$i]["name"]=$tmpplayer["player_".$i];
		$player[$i]["points"]=$tmpplayer["frags_".$i];
		$player[$i]["ping"]=$tmpplayer["ping_".$i];
		//Not integrated yet! $player[$i]["team"]=$tmpplayer["team_".$i];
		  $player[$i]["team"]="N/A";
	}

	// sort $player array
	if($sort!="none" AND $temp["numplayers"]>1) {
		if(function_exists("sort_by_".$sort)) {
			usort($player,"sort_by_".$sort);
		}
	}

	// return players information
	return $player;
    }


    // -- ut2k3_rules($address, $port) -- //
    function ut2k3_rules($address, $port) {

	// send command and receive answer
	$cmd="\\rules\\";
	$queryport=$port+10;
	if(!($response=getserverdata($address,$queryport,$cmd))) {
      return FALSE;
	}

	// seperate the answer
	$tmp=explode("\\",$response);
	for($i=1;$i<count($tmp);$i++) {
      $varname=$tmp[$i];
      $i++;
      $rules[$varname]=$tmp[$i];
	}

	// sync with GameserverQuery-protocol
      $rules["adminname"]=$rules["AdminName"];
      $rules["adminemail"]=$rules["AdminEMail"];
      return $rules;
    }
    
?>
