<?PHP
//##############################################################################
//## PMM - Webspec angepasst                                                  ##
//##############################################################################

  // ***************************************************************** //
  // *  UT2003 WebSpectator 1.1                                      * //
  // *  --------------------------------                             * //
  // *  Copyright 2002 Haider 'Gerde' Gerhard (gerde@blank-clan.de)  * //
  // *     and Ben 'smurf' Humpert - ut-2003.com                     * //
  // *     and Stefan 'moon' Thomas - ut-2003.com (moon@justmoon.com)* //
  // *                                                               * //
  // *                                                               * //
  // *  Description:                                                 * //
  // *  See the 'readme' for installation and other information      * //
  // *                                                               * //
  // *  Updates:                                                     * //
  // *  You can find all updates to the script @                     * //
  // *         http://ut.4players.de:1040/webspec/                   * //
  // *                                                               * //
  // *  You can report bugs to moon@justmoon.com                     * //
  // *                                                               * //
  // *  Version History -> 'readme'                                  * //
  // *                                                               * //
  // *  Notes:                                                       * //
  // *  Unreal and the Unreal logo are registered trademarks of Epic * //
  // *  Games, Inc. ALL RIGHTS RESERVED All other trademarks and     * //
  // *  trade names are the property of their respective owners      * //
  // *                                                               * //
  // ***************************************************************** //
  // * THIS SCRIPT IS RELEASED EXCLUSIVELY ON ut-2003.com, SO IF YOU * //
  // *    WANT TO REDISTRIBUTE IT, PLEASE MAIL moon@justmoon.com     * //
  // ***************************************************************** //

  ///////////////////////////////////////////////////////////////////////
  // Includes


$conf = array();
include("config.inc.php");
include("funcs.inc.php");

require("kopf.php");
require("serverview.inc.php");


$lang = array();
if(!file_exists($lfile = "./languages/".$conf['Language'].".inc.php")) { die("Language file '".$lfile."' not found!!"); }
include($lfile);


  ///////////////////////////////////////////////////////////////////////
  // Processing & Output

  // Check if $addr is given by the url or default should be used
  if($conf['AllowURL'] && isset($addr)) { 

    // check if port is given
    if(preg_match("#(.+):(.+)#",$addr,$match)) {
      $addr=$match[1];
      $port=$match[2];
    }
    else {
      $port="7777";
    }
  }
  else {
      $addr = $conf['IP']; 
      $port = $conf['port'];
  }

//Vars aus MM bergeben
if ($sip != "" and $sport != "") {
$addr = $sip;
$port = $sport;
}
  // Check if $sort_option for players-sorting is set or if default should be used 
  if(!isset($sort_option)) {
    $sort_option="points";
  }

  // Test if server is reachable and get infos,players and rules
  if($info = ut2k3_info($addr, $port)) {
	// Contact Master Server, if not already done so
	if($conf['AllowMaster'] && !file_exists("dont_delete_me"))
	{
		$fp = fopen ("http://ut.4players.de:1040/webspec/master.php?addr=".$addr."&port=".$port."&scripturl=".htmlentities($_SERVER['REQUEST_URI'])."&page=".htmlentities($conf['Homepage']), "r");
		fclose($fp);
		// make sure the script doesn't connect to the master again. Write rights required.
		$fp = fopen("dont_delete_me", "w");
		fputs($fp, "This file makes sure the script doesn't connect to the master again.");
		fclose($fp);
	}
      $rules   = ut2k3_rules($addr, $port);
      $players = ut2k3_players($addr, $port, $sort_option);

    // Output, still in the if(reachable)
//### Mapname in Kleinschreibung !! (Linux Server Anpassung !)
$mapname = strtolower($info["map"]);
?>
 <title>WebSpectator UT 2003 - <?PHP echo $info["hostname"]; ?> - <?PHP echo $info["numplayers"]."/".$info["maxplayers"]; ?> - <?PHP echo $info["mapname"]; ?></title>
 <table width="100%" height="1%" align="center">
  <tr>
   <th class="head" colspan="3">Server Spectator UT2003</th>
  </tr>
    <tr>
      <td width="15">&nbsp;</td>
      <td height="1%" width="1%" valign="top">
        <center>
          <table border="0" width="600" cellspacing="0" cellpadding="0" bgcolor="<?php echo $c_left; ?>" class="left">
            <tr>
              <td width="160" rowspan="7" height="128">
                <table border="0" cellspacing="0" cellpadding="0" >
                  <tr>
                    <td><? if(file_exists("./images/maps/".$mapname.".jpg")) {
                    	        echo "<IMG SRC=\"./images/maps/".$mapname.".jpg\" BORDER=\"0\">"; }
                    	   else {
                    	   	echo "<IMG SRC=\"./images/maps/unknown.jpg\" BORDER=\"0\"></td>"; }
                    	?>
                  </tr>
                </table>
              </td>
              <td width="20">&nbsp;</td>
              <td width="170"><?PHP echo $lang['Servername']; ?>:</td>
              <td width="300"><?PHP echo "<A HREF=\"unreal://".$info["address"].":".$info["port"]."\">".$info["hostname"]."</A>"; ?></td>
            </tr>
            <tr>
              <td width="20">&nbsp;</td>
              <td width="170"><?PHP echo $lang['IpAddress']; ?>:</td>
              <td width="300"><?PHP echo $info["address"]; ?></td>
            </tr>
            <tr>
              <td width="20">&nbsp;</td>
              <td width="170"><?PHP echo $lang['Port']; ?>:</td>
              <td width="300"><?PHP echo $info["port"]; ?></td>
            </tr>
            <tr>
              <td width="20">&nbsp;</td>
              <td width="170"><?PHP echo $lang['admin']; ?>:</td>
              <td width="300"><a href="mailto:<?PHP echo $rules["adminemail"]; ?>?subject=<?PHP echo $info["hostname"]; ?>"><?PHP echo $rules["adminname"]; ?></a></td>
            </tr>
            <tr>
              <td width="20">&nbsp;</td>
              <td width="170"><?PHP echo $lang['NumPlayers']; ?>:</td>
              <td width="300"><?PHP echo $info["numplayers"]."/".$info["maxplayers"]; ?></td>
            </tr>
            <tr>
              <td width="20">&nbsp;</td>
              <td width="170"><?PHP echo $lang['Map']; ?>:</td>
              <td width="300"><?PHP echo $info["mapname"]; ?> (<?PHP echo $info["map"]; ?>.ut2)</td>
            </tr>
            <tr>
              <td width="20">&nbsp;</td>
              <td width="170"><?PHP echo $lang['Gametype']; ?>:</td>
              <td width="300"><?PHP
                  if($info["gametype"]==xTeamGame) { echo $lang['ModeTDM']; }
                  elseif($info["gametype"]==xDeathMatch) { echo $lang['ModeDM']; }
                  elseif($info["gametype"]==xCTFGame) { echo $lang['ModeCTF']; }
                  elseif($info["gametype"]==xBombingRun) { echo $lang['ModeBR']; }
                  elseif($info["gametype"]==xDoubleDom) { echo $lang['ModeDOM']; }
                ?></td>
            </tr>
          </table>
          <TABLE width=600 CELLSPACING=0 CELLPADDING=0 BORDER=0 bgcolor="<?php echo $c_right; ?>" class="right">
            <TR>
              <td colspan="5">&nbsp;</td>
            </TR>
            <?PHP
              if($info["numplayers"]>0) {
                $startnumber=$info["numplayers"]-1;
                echo "<TR>";
                echo "  <TD width=\"132\">&nbsp;</TD>";
                echo "  <TD width=\"220\"><B><A HREF=\"".$PHP_SELF."?addr=".$info["address"].":".$info["port"]."&sort_option=name\">".$lang['playername']."</A></B></TD>";
//                echo "  <TD width=\"84\"><B><A HREF=\"".$PHP_SELF."?addr=".$info["address"].":".$info["port"]."&sort_option=team\">".$lang['team']."</A></B></TD>";
                echo "  <TD width=\"83\"><B><A HREF=\"".$PHP_SELF."?addr=".$info["address"].":".$info["port"]."&sort_option=points\">".$lang['points']."</A></B></TD>";
                echo "  <TD width=\"83\"><B><A HREF=\"".$PHP_SELF."?addr=".$info["address"].":".$info["port"]."&sort_option=ping\">".$lang['ping']."</A></B></TD>";
                echo "  <TD width=\"132\">&nbsp;</TD>";
                echo "</TR>";
                echo "<TR>";
                echo "  <TD colspan=\"5\" align=\"center\">&nbsp;</TD>";
                echo "</TR>";
                for($i=$startnumber;$i>=0;$i--) {
                  echo "<TR>";
                  echo "  <TD width=\"132\">&nbsp;</TD>";
                  echo "  <TD width=\"220\">".$players[$i]["name"]."</TD>";
//                  echo "  <TD width=\"84\">".$players[$i]["team"]."</TD>";
                  echo "  <TD width=\"83\">".$players[$i]["points"]."</TD>";
                  echo "  <TD width=\"83\">".$players[$i]["ping"]."</TD>";
                  echo "  <TD width=\"132\">&nbsp;</TD>";
                  echo "</TR>";
                }
                echo "<TR>";
                echo "  <TD colspan=\"5\" align=\"center\">&nbsp;</TD>";
                echo "</TR>";
              }
              else {
                echo "<TR>";
                echo "  <TD width=\"132\">&nbsp;</TD>";
                echo "  <TD width=\"220\"><B><A HREF=\"".$PHP_SELF."?addr=".$info["address"].":".$info["port"]."&sort_option=name\">".$lang['playername']."</A></B></TD>";
//                echo "  <TD width=\"84\"><B><A HREF=\"".$PHP_SELF."?addr=".$info["address"].":".$info["port"]."&sort_option=team\">".$lang['team']."</A></B></TD>";
                echo "  <TD width=\"83\"><B><A HREF=\"".$PHP_SELF."?addr=".$info["address"].":".$info["port"]."&sort_option=points\">".$lang['points']."</A></B></TD>";
                echo "  <TD width=\"83\"><B><A HREF=\"".$PHP_SELF."?addr=".$info["address"].":".$info["port"]."&sort_option=ping\">".$lang['ping']."</A></B></TD>";
                echo "  <TD width=\"132\">&nbsp;</TD>";
                echo "</TR>";
                echo "<TR>";
                echo "  <TD colspan=\"5\" align=\"center\">&nbsp;</TD>";
                echo "</TR>";
                echo "<TR>";
                echo "  <TD width=\"132\">&nbsp;</TD>";
                echo "  <TD colspan=\"3\" width=\"386\" align=\"center\">".$lang['NoPlayers']."</TD>";
                echo "  <TD width=\"132\">&nbsp;</TD>";
                echo "</TR>";
                echo "<TR>";
                echo "  <TD colspan=\"5\" align=\"center\">&nbsp;</TD>";
                echo "</TR>";
              }
            ?>
          </TABLE>
        </center>
      </td>
      <td width="15">&nbsp;</td>
    </tr>
  </table>
<?PHP
}
else { // Couldn't get the info, printing out error
?>
 <title>WebSpectator - <?PHP echo $lang['ErrorConnect']; ?></title>
 <table width="100%" height="1%" align="center">
  <tr>
   <th class="head" colspan="3">Server Spectator UT2003</th>
  </tr>
    <tr>
      <td colspan="3" height="25"></td>
    </tr>
    <tr>
      <td width="15">&nbsp;</td>
      <td valign="top">
        <center>
	  <TABLE width=600 CELLSPACING=0 CELLPADDING=0 BORDER=0 bgcolor="<?PHP echo $c_inner_tb_bg; ?>">
            <TR>
              <td align="center"><img src="./images/error.jpg"></td>
            </TR>
            <TR>
            <TD align="center">&nbsp;</TD>
            </TR>
            <TR>
            <TD align="center"><?PHP echo $lang['ErrorConnect']; ?><br><?PHP echo $addr.":".$port; ?></TD>
            </TR>
            <TR>
            <TD align="center">&nbsp;</TD>
            </TR>
          </TABLE>
        </center>
      </td>
      <td width="15">&nbsp;</td>
    </tr>
    <tr>
      <td colspan="3" height="25"></td>
    </tr>
  </table>
<?PHP
} // Please leave this function in there or you are violating copyright law.
ads();

echo "<table width=\"100%\" border=\"0\">
      <tr>
       <td class=\"info\">
        <img src=\"images/cat.gif\">
        <a href=\"$PHP_SELF?sip=$sip&sport=$sport&sid=$sid\">Aktualisieren</a> /
        <a href=\"server.php\">Serverliste</a>
       </td>
      </tr></table>";


require("fuss.php");

//Servername in der DB Updaten
if($info[hostname] != "") {
$info[hostname] = addslashes($info[hostname]);
$sqlbefehl = "Update $tab_server
              Set servername='$info[hostname]'
              Where id='$sid'";
if (!$ergebnis  = mysql_query($sqlbefehl, $serverid))
echo mysql_error($serverid);
}
?>
